/**
 * Copyright 2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 */
package com.sunlabs.archsim.assignJan25;

import com.sunlabs.archsim.gasp.Branch;
import com.sunlabs.archsim.gasp.BranchAction;

/**
 * Branch - two outputs, directs an output to them in an alternating fashion.
 * @author ib27688
 *
 */
public class Toggle extends Branch {
	
	public Toggle(String name) {
		super(name, 2, new ToggleAction(2) );
	}	
} // Toggle

class ToggleAction extends BranchAction {
	static final String name= "ToggleAction";
	
	int nextBranch;
	
	public ToggleAction(int numOut) {
		super(name, numOut);
		nextBranch= 0;
	}
		
	public int selectBranch(Object data) {
		int s= nextBranch;
		nextBranch= (nextBranch+1) % numBranches;
		return s;
	}
} // ToggleAction