/*
 * Copyright � 2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */
/*
 * Created on October 21, 2005
 *
 */
package com.sunlabs.archsim.fleet.ships.tokenaccumulator;

import com.sunlabs.archsim.base.simulation.Delay;

/**
 * @author mh193489
 *
 * Accumulator ship defaults.
 */
public class TokenAccumulatorDefaults {

	private TokenAccumulatorDefaults() {}
	
	public static final String ACCUMULATOR= "accumulator";
	public static final String ACCUMULATING_ACTION= "accumulatingAction";
	public static final String OUTPUT_ACTION= "outputAction";
        
	public static final String DATA_IN= "DataIn";
	public static final String ACK_DATA_IN= "ackDataIn";

	public static final String DATA_OUT= "DataOut";
	public static final String ACK_DATA_OUT= "ackDataOut";	

        public static final String TOKEN_IN= "TokenIn";
	public static final String ACK_TOKEN_IN= "ackTokenIn";
	
	public static final String TOKEN_OUT= "TokenOut";
	public static final String ACK_TOKEN_OUT= "ackTokenOut";	
        
        
        public static final String INTERNAL_DATA_IN= "InternalDataIn";
        public static final String ACK_INTERNAL_DATA_IN= "ackInternalDataIn";

        public static final String INTERNAL_DATA_OUT= "InternalDataOut";
	public static final String ACK_INTERNAL_DATA_OUT= "ackInternalDataOut";

        public static final String INTERNAL_TOKEN_IN= "InternalTokenIn";
        public static final String ACK_INTERNAL_TOKEN_IN= "ackInternalTokenIn";

        public static final String INTERNAL_TOKEN_IN_DUMMY= "InternalTokenIn";
        public static final String ACK_INTERNAL_TOKEN_IN_DUMMY= "ackInternalTokenIn";

        
        public static final String INTERNAL_DATA_STATE= "InternalDataState";
	public static final String ACK_INTERNAL_DATA_STATE= "AckInternalDataState";
        public static final String INTERNAL_TOKEN_STATE= "InternalTokenState";
	public static final String ACK_INTERNAL_TOKEN_STATE= "AckInternalTokenState";
        

        
        public static final Delay ACCUMULATING_DELAY= new Delay(10);
        public static final Delay OUTPUT_DELAY= new Delay(10);
	
	/** accumulator ack delay identifier */
	public static String ACCUMULATOR_ACK_DELAY= "tokenAccumulatorAckDelay";
	/** default ack delay */
	public static final Delay ACCUMULATOR_ACK_DELAY_DEF= new Delay(10);

        /** accumulator ack delay identifier */
	public static String ACCUMULATOR_OUT_DELAY= "tokenAaccumulatorAckDelayccumulatorOutDelay";
	/** default ack delay */
	public static final Delay ACCUMULATOR_OUT_DELAY_DEF= new Delay(10);

        public static final int OVERFLOW= Integer.MAX_VALUE;
        public static final int UNDERFLOW= Integer.MIN_VALUE;
        public static final int PLUS_INFINITY= 1;
        public static final int MINUS_INFINITY= -1;

} // class AccumulatorDefaults
